/****************************************************************
*	MCB.H - definitions & prototypes for handling MCBs			*
****************************************************************/

#define mcbRSRVD	11					/* Size of reserved area*/
#define mcbSIZE		16					/* Size of DOS' MCB		*/

typedef struct
	{
	char			marker;				/* Chain status marker	*/
	unsigned int	owner;				/* Owner of block (PSP)	*/
	unsigned int	size;				/* Size of block (para)	*/
	unsigned char	reserved[mcbRSRVD];	/* Currently unused		*/
	} MCB;

/* Function prototypes of getFirstMCB() and getNextMCB()		*/
MCB far *getFirstMCB(void);				/* Get addr of first MCB*/
MCB far *getNextMCB(MCB far *);			/* Get addr of next MCB	*/

/* macro pseudoFunction for getNextMCB()						*/
#define getNextMCB(x)	((MCB far *)MK_FP(FP_SEG(x)+x->size+1,0))
